/*
 * oled Oscilloscope
 *
 * Created: 10/02/2021
 *  Author: moty22.co.uk
 */ 
#include <Wire.h>

unsigned char addr=0x3C;  //0x78, amp, v
unsigned char smp[64];
void setup() {
    pinMode(A0, INPUT);
    pinMode(2, INPUT_PULLUP);
    Wire.begin();        // init i2c bus
    Wire.setClock(400000);  //400khz
    oled_init();
    clrScreen();
}

void loop()
{
    unsigned char m, v;
    for(unsigned char i = 0; i < 64; i++){
      smp[i]=analogRead(A0);
      if(! digitalRead(2)) delay(1);
    }
    
    for (unsigned char j = 0; j < 64; j++){
      v = 64 - smp[j]/4;  
      command(0x21);     //col addr
      command(j*2); //col start
      command(j*2);  //col end
      command(0x22);    //0x22
      command(v/8); // Page start
      command(v/8); // Page end
      
      m = v % 8;
      if(m>2){m=pow(2,m-1)+1;}
      Wire.beginTransmission(addr);
      Wire.write(0x40);
      Wire.write(m);
      Wire.endTransmission(); 
    }

    delay(1000);
    clrScreen();
}

void clrScreen()    //fill screen with 0
{
    unsigned char x;
    
      for (x = 0; x < 64; x++){
          command(0x21);     //col addr
          command(2 * x); //col start
          command(2 * x + 1);  //col end
          command(0x22);    //0x22
          command(0); // Page start
          command(7); // Page end
          
          Wire.beginTransmission(addr);
          Wire.write(0x40);
          for (unsigned char i = 0; i < 16; i++){
               Wire.write(0x00);          
          }
          Wire.endTransmission();         
      }

}


void command( unsigned char comm){
    Wire.beginTransmission(addr); 
    Wire.write(0x00);    
    Wire.write(comm); // LSB
    Wire.endTransmission();       
}

void oled_init() {
    
    command(0xAE);   // DISPLAYOFF
    command(0x8D);         // CHARGEPUMP *
    command(0x14);     //0x14-pump on
    command(0x20);         // MEMORYMODE
    command(0x01);      //0x0=horizontal, 0x01=vertical, 0x02=page
    command(0xA1);        //SEGREMAP * A0/A1=top/bottom 
    command(0xC8);     //COMSCANDEC * C0/C8=left/right
    command(0xDA);         // SETCOMPINS *
    command(0x12);   //0x22=4rows, 0x12=8rows
    command(0x81);        // SETCONTRAST
    command(0xFF);     //0x8F
    //next settings are set by default
//    command(0xD5);  //SET DISPLAY CLOCK DIV 
//    command(0x80);  
//    command(0xA8);       // SETMULTIPLEX
//    command(0x3F);     //0x1F
//    command(0xD3);   // SETDISPLAYOFFSET
//    command(0x0);  
//    command(0x40); // SETSTARTLINE  
//    command(0xD9);       // SETPRECHARGE
//    command(0xF1);
//    command(0xDB);      // SETVCOMDETECT
//    command(0x40);
//    command(0xA4);     // DISPLAYALLON_RESUME
//    command(0xA6);      // NORMALDISPLAY
    command(0xAF);          //DISPLAYON

}
